Extension { #name : 'RcBtreeLeafNode' }

{ #category : 'Updating' }
RcBtreeLeafNode >> at: aKey put: aValue [

self shouldNotImplement: #at:put:

]

{ #category : 'Updating' }
RcBtreeLeafNode >> btreeAt: aKey put: aValue [

""

self shouldNotImplement: #btreeAt:put:

]

{ #category : 'Updating' }
RcBtreeLeafNode >> btreeAt: aKey put: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil [

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := super at: aKey put: aValue.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res

]

{ #category : 'Constants' }
RcBtreeLeafNode >> parentNodeClass [

"Returns the class of node to be created as the parent when a split occurs."

^ RcBtreeInteriorNode

]

{ #category : 'Removing' }
RcBtreeLeafNode >> removeKey: aKey value: aValue [

self shouldNotImplement: #removeKey:value:

]

{ #category : 'Removing' }
RcBtreeLeafNode >> removeKey: aKey value: aValue for: anIndexObj selectiveAbortSet: selectiveAbortSetOrNil [

| res |
(selectiveAbortSetOrNil ~~ nil and: [ (selectiveAbortSetOrNil includes: self) not ])
        ifTrue: [
                selectiveAbortSetOrNil add: self.
                self _selectiveAbort ].
res := super removeKey: aKey value: aValue.
System _addRootObjectToRcReadSet: self.
System redoLog addConflictObject: self for: anIndexObj.
^res

]
